'
.RS
.TP
\fBPixel Attachment\fR
'
The pixel attachment is given by an integer number. If the integer is
zero or positive, it specifies a displacement from the top or left
edge of the master window. If the integer is negative or "\fB-0\fR",
it specifies a displacement from the bottom or right edges of the
master.  For example, "\fB-top 0\fR" specifies that the top side of
the slave window should be attached to the top edge of the master.
"\fB-right -0\fR" means the right side of the slave should be attached
to the right edge of the master. Moreover, "\fB-top 4\fR" attaches the
top side of the slave to 4 pixels lower than the top edge of the
master. "\fB-right -100\fR" attaches the right side of the slave to
100 pixels to the left of the right side of the master.
'
.TP
\fBOpposite Widget Attachment\fR
'
It attaches the specified side of the slave to the \fIopposite\fR side
of another slave widget, which must be managed by the same master
window. For example, "\fBtixForm .c -top .b\fR" attaches the top side
of the slave \fB.c\fR to the bottom side of the slave .b. "\fB-left .b\fR"
attaches the left side of the slave to the right side of the
slave \fB.b\fR.
'
.TP
\fBParallel Widget Alignment\fR
'
It aligns the specified side of the slave to the \fIsame\fR side of
another slave widget, which must be managed by the same master window.
Parallel attachment is specified by putting the & prefix at the front
of the pathname of the other widget. For example, "\fBtixForm .c -top
&.b\fR" aligns the top side of \fB.c\fR to the top side of \fB.b\fR.
"\fB-right &.b\fR" aligns the right side of the slave to the right
side of the slave \fB.b\fR.
'
.TP
\fB"None" Attachment\fR
'
This specifies a side of the slave to be attached to nothing. The
syntax is, "\fB-top none\fR", "\fB-bottom none\fR", "\fB-left none\fR"
and "\fB-right none\fR".

When a side of a slave is attached to "\fBnone\fR", the position of
this side is calculated by the position of the other side and the
natural size of the slave. For example, if a the left side of a widget
is attached to pixel \fB100\fR and the natural size of the widget is
\fB50\fR pixels, the right side of the widget will be positioned at
pixel \fB149\fR.

When both \fB-top\fR and \fB-bottom\fR are attached to \fBnone\fR,
then by default \fB-top\fR will be attached to the top edge of the
master. When both \fB-left\fR and \fB-right\fR are attached to none,
then by default \fB-left\fR will be attached to the left edge of the
master.

.TP
\fBgrid attachment\fR
'
This attachment is specified by a non-negative integer prefixed by the
character "\fB%\fR". 

By default the grid of a master window is divided into a 100x100 grid,
and hence the grid attachment is percentage attachment. The grid of a
master can be changed by the \fBtixForm grid\fR command.

For example, "\fBtixForm .b -left %20\fR" attaches the left side of \fB.b\fR
to 20% of the horizontal dimension of the master. "\fB-top
%70\fR" attaches the top side of the slave to 90% of the vertical
dimension of the master.

The grid value must not exceed the number of grids in the master
window. Otherwise an error is generated.
'
.TP
\fBdefault attachment values\fR
'
By default, a slave is attached by "\fB-top none -left none -bottom
none -right none\fR".
.RE